Versionsverlauf
===============

## [Noch nicht veröffentlicht]

## [Version 1.11.5] - 2019-08-02

- Initialisierung des Logger der Applikation korrigiert, so dass RuntimeExceptions, 
  die zum Beenden der Parametrierung führen, potentiell geloggt werden können.
- Anpassungen zur Kompatibilität funclib.bitctrl Version 1 und 2
- Parametrierung sendet einen leeren Parameterdatensatz und kein KEINE_DATEN, wenn
  keine Datenbank bzw. kein gespeicherter Parameter vorhanden ist

## [Version 1.11.4]

- NERZ: Umstellung auf Gradle, Build durch FTB und Bereitstellung auf NERZ-Repositories

## Version 1.11.3

- Fehler im Klassenpfad korrigiert, der das starten der Derby-Datenbank verhindetr hat.

## Version 1.11.2

- der Parameterdatensatz der Parametrierung wird jetzt auch über die Methodenbibliothek
  ausgeliefert und kann über diese geschrieben werden

## Version 1.11.1

- Fehlerhafte Logausgabe, wenn es keine Änderungen im Settingsmanager gibt. Diese wurde
  verursacht, weil dann keine "update"-Methode aufgerufen wurde und der Beginn der
  Änderungen damit nicht bestimmbar war.

## Version 1.11.0

- Quellen auf UTF-8 umgestellt
- erforderliche Java-Version 8
- Korrekturen bei den Logausgaben
- Optimierung beim Ermitteln der konfigurierten Standardparameter

## Version 1.10.5

- Beim Initialisieren der Parametrierung konnten unvollständige Parameterdatensätze entstehen wenn
  in Konfigurationsbereichen die Historie nicht mehr vorhanden war oder Konfigurationsbereiche
  komplett entfenrt wurden.
  Der Versuch einen solchen unvollständigen Datensatz zu versenden hat dann zum Beenden der 
  Parametrierung geführt.

## Version 1.10.4

- Bei Antworten über die Parameterschnittstelle muss die Parametrierung sich selbst als Absender eintragen.
  Bisher wurde die anfragende Applikation eingesetzt, was ab Kernsoftware 3.6.5 nicht mehr akzeptiert wird.

## Version 1.10.3

- In seltenen Fällen konnten Parameter nicht mehr gespeichert werden, die zuvor gelöscht wurden.
  (SQL-Index-Fehler)

## Version 1.10.2

- Derby-Persizenz konnte unter Umständen nicht initialisiert werden,
  wenn zuvor ein lokaler Parameter gelöscht wurde.

## Version 1.10.1

- neue Parameter-Bibliothek eingebunden, 
  potentielle NPE beim Serialisieren der Datnsätze

## Version 1.10.0

- Umstellung auf Maven-Build.
- Parameter werden mit Zeitstempel der letzten Änderung veröffentlicht
- Ungültige Objektreferenzen werden nach Möglichkeit repariert

## Version 1.9.5

- erweiterte Logausgaben mit Systemobjekten.

## Version 1.9.4

- die Optimierung in Version 1.9.0 hat dazu geführt, dass nur noch bestehende Parameter aktualisiert werden
  aber keine neuen angelegt (gespeichert) werden konnten.
  
## Version 1.9.3

- unter bestimmten Umständen konnte eine Datenabfrage in Verbindung mit dem aktualisierten Parameterbibliothek
  zu einer NPE in der Parametrierung führen

## Version 1.9.2

- potentielles Problem bei der Parametrierung von Simulationen (ConcurrentModificationException)
- Synchronisationskorrekturen des Caches innerhalb der Derby-Persitenz

## Version 1.9.1

- Korrekturen bei der Synchronisation des Parameter-Senders
- wiederholte Anforderungen zum Parametrieren werden ignoriert, wenn die Speicherung noch nicht erfolgt ist
 
## Version 1.9.0

Die Parametrierung liefert einen speziellen Quelltyp, wenn der Abruf der Parameter ohne Daten erfolgt 

## Version 1.8.2

Die Parametrierung wurde unter Umständen beendet, wenn die Antwort auf eine Anfrage über die Methodenbibliothek
nicht mehr versendet werden konnte, weil der Anfrager nicht mehr als Empfänger für die Antwort registriert war.
Das Setzen von Parametern über Hierarchie-Objekte war mit der unter 1.8.1 vorgenommenen Optiomierung
unter Umständen nicht mehr möglich.

## Version 1.8.1

Parameterdaten können nur geschrieben werden, wenn die Parameter auch gemäß der Definition des 
Parameterdatensatzes der Parametrierung veröffentlicht werden.


## Version 1.8.0

Die Parametrierung versteht Anforderungen zur Steuerung, insbesondere zum Esrtellen eines Backups.


## Version 1.7.11

Die Anfrage nach konfigurierbaren Objekten beinhaltet das Objekt selbst, wenn bei der Anfrage kein Typ oder Hierarchieobjekt
übergeben wurde.

## Version 1.7.10

IllegalStateException beim Empfang von Datensätzen wird abgefangen. Diese tritt auf, wenn von einem gekoppelten Datenverteiler 
Parameterdatensätze empfangen werden, die unbekannte Objekte referenzieren.

## Version 1.7.5

- Synchronisation der Listenerliste beim SimulationsStatusObserver verhindert Exceptions beim Starten/Beenden von Simulationen

## Version 1.7.2

- Bereinigung der Datenbank synchronisiert.
  
## Version 1.7.1

- Zusätzlicher Parametrierung, um die Verzögerung der Fertigmeldung der Applikation
  durch den SettingsManager zu erlauben

## Version 1.6.0

- Die Parametrierung funktioniert jetzt auch, wenn die Rechteprüfung des
  Datenverteilers eingeschalten ist.
  (Kommandozeilenargument von Transmitter: -rechtePruefung=ja)

## Version 1.2.0

- Die Methodenbibliothek wurde in ein einzelnes Paket ausgelagert.
- Die Paketnamen wurden an die Kernsoftwareversion angepasst.

## Version 1.1.0

- Anpassungen bei der Speicherung von Hierarchieobjekten.

## Version 1.0.2

- Die Parameter des AOE-Objekts selbst konnten bisher nicht parametriert werden.
  Das wurde korrigiert.


[Noch nicht veröffentlicht]: https://gitlab.nerz-ev.de/ERZ/SWE_de.bsvrz.puk.param/compare/v1.11.5...HEAD
[Version 1.11.5]: https://gitlab.nerz-ev.de/ERZ/SWE_de.bsvrz.puk.param/compare/v1.11.4...v1.11.5
[Version 1.11.4]: https://gitlab.nerz-ev.de/ERZ/SWE_de.bsvrz.puk.param/compare/v1.11.3...v1.11.4
